/* mem.c
 *
 * Copyright 2018 Bruce Cowan <bruce@bcowan.me.uk>
 *
 * This file is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 3 of the
 * License, or (at your option) any later version.
 *
 * This file is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * SPDX-License-Identifier: LGPL-3.0-or-later
 */

#include "mem.h"

#include <stdlib.h>

void *
check_malloc (size_t size)
{
    void *ptr = malloc (size);
    if (!ptr)
        exit (EXIT_FAILURE);

    return ptr;
}

void *
check_realloc (void   *ptr,
               size_t  size)
{
    void *new = realloc (ptr, size);
    if (!new)
        exit (EXIT_FAILURE);

    return new;
}
